﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using MySql.Data.MySqlClient;

namespace ConsoleApplication1
{
	class Program
	{
		static void Main(string[] args)
		{
			MySqlConnection sqlConnection = new MySqlConnection("Data Source=localhost;Uid=root;Pwd=password;Database=testdb;");

			MySqlCommand sqlSelectCommand = new MySqlCommand("SELECT `PrimaryKey` FROM `TableWithDateAsPrimaryKey`", sqlConnection);
			GetSchemaTable(sqlConnection, sqlSelectCommand);

			MySqlCommand sqlSelectCommand2 = new MySqlCommand("SELECT `PrimaryKey` FROM `TableWithStringAsPrimaryKey`", sqlConnection);
			GetSchemaTable(sqlConnection, sqlSelectCommand);
		}

		private static DataTable GetSchemaTable(MySqlConnection sqlConnection, MySqlCommand sqlSelectCommand)
		{
			DataTable dataTableSchema = new DataTable();
			bool isClosed = ConnectionState.Closed == sqlConnection.State;

			try
			{
				if (isClosed)
				{
					sqlConnection.Open();
				}

				IDataReader sqlDataReader = sqlSelectCommand.ExecuteReader(CommandBehavior.KeyInfo);
				dataTableSchema = sqlDataReader.GetSchemaTable();
				sqlSelectCommand.Cancel();
				sqlDataReader.Close();
			}
			finally
			{
				if (sqlConnection.State != ConnectionState.Closed)
				{
					sqlConnection.Close();
				}
			}

			return dataTableSchema;
		}
	}
}
